;==========================================
;created with ==>MASM IDE version 5.3
;written by "OSSAMA.H"
;email==>ossama_dev@hotmail.com
;==========================================

.586
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

include macros.asm

.data
	szAppName	db	"Simple Window",0
	hInstance	dd	?
	h_menu	dd	?

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax

	invoke LoadMenu,hInstance,sz("simple_popup")
	mov h_menu,eax

	call WinMain

	invoke DestroyMenu,h_menu

	invoke ExitProcess, eax

WinMain proc
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov   wc.cbSize, SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra, NULL
	mov   wc.cbWndExtra, NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground, COLOR_WINDOW+1
	mov   wc.lpszMenuName, NULL
	mov   wc.lpszClassName,sz("ossama32")
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov   wc.hIcon, eax
	mov   wc.hIconSm, eax
	invoke LoadCursor, NULL, IDC_ARROW
	mov   wc.hCursor, eax
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,sz("ossama32"),ADDR szAppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInstance,NULL
	mov   hwnd, eax
	invoke ShowWindow, hwnd, SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	@@:
		invoke GetMessage, ADDR msg, NULL, 0, 0
		cmp eax,0
		je @F
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
		jmp @B
	@@:
	return 0
WinMain endp

WndProc proc hWnd:HWND,message:UINT, wParam:WPARAM, lParam:LPARAM
	local pt:POINT

	.if message==WM_LBUTTONUP
		invoke GetCursorPos,addr pt
		invoke TrackPopupMenu,h_menu,TPM_LEFTALIGN+TPM_LEFTBUTTON,pt.x,pt.y,0,hWnd,0
	.elseif message==WM_DESTROY
		invoke PostQuitMessage, NULL
	.else
		invoke DefWindowProc, hWnd,message, wParam, lParam		
		ret
	.endif
	return 0
WndProc endp
end start